diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-cubic.cc ns-3.33/src/internet/model/tcp-cubic.cc
--- ns-3.32/src/internet/model/tcp-cubic.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/internet/model/tcp-cubic.cc	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,456 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2014 Natale Patriciello <natale.patriciello@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#define NS_LOG_APPEND_CONTEXT \
+  { std::clog << Simulator::Now ().GetSeconds () << " "; }
+
+#include "tcp-cubic.h"
+#include "ns3/log.h"
+
+NS_LOG_COMPONENT_DEFINE ("TcpCubic");
+
+namespace ns3 {
+
+NS_OBJECT_ENSURE_REGISTERED (TcpCubic);
+
+TypeId
+TcpCubic::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::TcpCubic")
+    .SetParent<TcpSocketBase> ()
+    .AddConstructor<TcpCubic> ()
+    .SetGroupName ("Internet")
+    .AddAttribute ("FastConvergence", "Enable (true) or disable (false) fast convergence",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&TcpCubic::m_fastConvergence),
+                   MakeBooleanChecker ())
+    .AddAttribute ("Beta", "Beta for multiplicative decrease",
+                   DoubleValue (0.7),
+                   MakeDoubleAccessor (&TcpCubic::m_beta),
+                   MakeDoubleChecker <double> (0.0))
+    .AddAttribute ("HyStart", "Enable (true) or disable (false) hybrid slow start algorithm",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&TcpCubic::m_hystart),
+                   MakeBooleanChecker ())
+    .AddAttribute ("HyStartLowWindow", "Lower bound cWnd for hybrid slow start (segments)",
+                   UintegerValue (16),
+                   MakeUintegerAccessor (&TcpCubic::m_hystartLowWindow),
+                   MakeUintegerChecker <uint32_t> ())
+    .AddAttribute ("HyStartDetect", "Hybrid Slow Start detection mechanisms:" \
+                   "1: packet train, 2: delay, 3: both",
+                   IntegerValue (3),
+                   MakeIntegerAccessor (&TcpCubic::m_hystartDetect),
+                   MakeIntegerChecker <int> (1,3))
+    .AddAttribute ("HyStartMinSamples", "Number of delay samples for detecting the increase of delay",
+                   UintegerValue (8),
+                   MakeUintegerAccessor (&TcpCubic::m_hystartMinSamples),
+                   MakeUintegerChecker <uint8_t> ())
+    .AddAttribute ("HyStartAckDelta", "Spacing between ack's indicating train",
+                   TimeValue (MilliSeconds (2)),
+                   MakeTimeAccessor (&TcpCubic::m_hystartAckDelta),
+                   MakeTimeChecker ())
+    .AddAttribute ("HyStartDelayMin", "Minimum time for hystart algorithm",
+                   TimeValue (MilliSeconds (4)),
+                   MakeTimeAccessor (&TcpCubic::m_hystartDelayMin),
+                   MakeTimeChecker ())
+    .AddAttribute ("HyStartDelayMax", "Maximum time for hystart algorithm",
+                   TimeValue (MilliSeconds (1000)),
+                   MakeTimeAccessor (&TcpCubic::m_hystartDelayMax),
+                   MakeTimeChecker ())
+    .AddAttribute ("CubicDelta", "Delta Time to wait after fast recovery before adjusting param",
+                   TimeValue (MilliSeconds (10)),
+                   MakeTimeAccessor (&TcpCubic::m_cubicDelta),
+                   MakeTimeChecker ())
+    .AddAttribute ("CntClamp", "Counter value when no losses are detected (counter is used" \
+                   " when incrementing cWnd in congestion avoidance, to avoid" \
+                   " floating point arithmetic). It is the modulo of the (avoided)" \
+                   " division",
+                   UintegerValue (20),
+                   MakeUintegerAccessor (&TcpCubic::m_cntClamp),
+                   MakeUintegerChecker <uint8_t> ())
+    .AddAttribute ("C", "Cubic Scaling factor",
+                   DoubleValue (0.4),
+                   MakeDoubleAccessor (&TcpCubic::m_c),
+                   MakeDoubleChecker <double> (0.0))
+  ;
+  return tid;
+}
+
+TcpCubic::TcpCubic ()
+  : TcpCongestionOps (),
+    m_cWndCnt (0),
+    m_lastMaxCwnd (0),
+    m_bicOriginPoint (0),
+    m_bicK (0.0),
+    m_delayMin (Time::Min ()),
+    m_epochStart (Time::Min ()),
+    m_found (false),
+    m_roundStart (Time::Min ()),
+    m_endSeq (0),
+    m_lastAck (Time::Min ()),
+    m_cubicDelta (Time::Min ()),
+    m_currRtt (Time::Min ()),
+    m_sampleCnt (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TcpCubic::TcpCubic (const TcpCubic &sock)
+  : TcpCongestionOps (sock),
+    m_fastConvergence (sock.m_fastConvergence),
+    m_beta (sock.m_beta),
+    m_hystart (sock.m_hystart),
+    m_hystartDetect (sock.m_hystartDetect),
+    m_hystartLowWindow (sock.m_hystartLowWindow),
+    m_hystartAckDelta (sock.m_hystartAckDelta),
+    m_hystartDelayMin (sock.m_hystartDelayMin),
+    m_hystartDelayMax (sock.m_hystartDelayMax),
+    m_hystartMinSamples (sock.m_hystartMinSamples),
+    m_initialCwnd (sock.m_initialCwnd),
+    m_cntClamp (sock.m_cntClamp),
+    m_c (sock.m_c),
+    m_cWndCnt (sock.m_cWndCnt),
+    m_lastMaxCwnd (sock.m_lastMaxCwnd),
+    m_bicOriginPoint (sock.m_bicOriginPoint),
+    m_bicK (sock.m_bicK),
+    m_delayMin (sock.m_delayMin),
+    m_epochStart (sock.m_epochStart),
+    m_found (sock.m_found),
+    m_roundStart (sock.m_roundStart),
+    m_endSeq (sock.m_endSeq),
+    m_lastAck (sock.m_lastAck),
+    m_cubicDelta (sock.m_cubicDelta),
+    m_currRtt (sock.m_currRtt),
+    m_sampleCnt (sock.m_sampleCnt)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+std::string
+TcpCubic::GetName () const
+{
+  return "TcpCubic";
+}
+
+void
+TcpCubic::HystartReset (Ptr<const TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this);
+
+  m_roundStart = m_lastAck = Simulator::Now ();
+  m_endSeq = tcb->m_highTxMark;
+  m_currRtt = Time::Min ();
+  m_sampleCnt = 0;
+}
+
+void
+TcpCubic::IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked);
+
+  if (tcb->m_cWnd < tcb->m_ssThresh)
+    {
+
+      if (m_hystart && tcb->m_lastAckedSeq > m_endSeq)
+        {
+          HystartReset (tcb);
+        }
+
+      // In Linux, the QUICKACK socket option enables the receiver to send
+      // immediate acks initially (during slow start) and then transition
+      // to delayed acks.  ns-3 does not implement QUICKACK, and if ack
+      // counting instead of byte counting is used during slow start window
+      // growth, when TcpSocket::DelAckCount==2, then the slow start will
+      // not reach as large of an initial window as in Linux.  Therefore,
+      // we can approximate the effect of QUICKACK by making this slow
+      // start phase perform Appropriate Byte Counting (RFC 3465)
+      tcb->m_cWnd += segmentsAcked * tcb->m_segmentSize;
+      segmentsAcked = 0;
+
+      NS_LOG_INFO ("In SlowStart, updated to cwnd " << tcb->m_cWnd <<
+                   " ssthresh " << tcb->m_ssThresh);
+    }
+
+  if (tcb->m_cWnd >= tcb->m_ssThresh && segmentsAcked > 0)
+    {
+      m_cWndCnt += segmentsAcked;
+      uint32_t cnt = Update (tcb);
+
+      /* According to RFC 6356 even once the new cwnd is
+       * calculated you must compare this to the number of ACKs received since
+       * the last cwnd update. If not enough ACKs have been received then cwnd
+       * cannot be updated.
+       */
+      if (m_cWndCnt >= cnt)
+        {
+          tcb->m_cWnd += tcb->m_segmentSize;
+          m_cWndCnt -= cnt;
+          NS_LOG_INFO ("In CongAvoid, updated to cwnd " << tcb->m_cWnd);
+        }
+      else
+        {
+          NS_LOG_INFO ("Not enough segments have been ACKed to increment cwnd."
+                       "Until now " << m_cWndCnt << " cnd " << cnt);
+        }
+    }
+}
+
+uint32_t
+TcpCubic::Update (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this);
+  Time t;
+  uint32_t delta, bicTarget, cnt = 0;
+  double offs;
+  uint32_t segCwnd = tcb->GetCwndInSegments ();
+
+  if (m_epochStart == Time::Min ())
+    {
+      m_epochStart = Simulator::Now ();   // record the beginning of an epoch
+
+      if (m_lastMaxCwnd <= segCwnd)
+        {
+          NS_LOG_DEBUG ("lastMaxCwnd <= m_cWnd. K=0 and origin=" << segCwnd);
+          m_bicK = 0.0;
+          m_bicOriginPoint = segCwnd;
+        }
+      else
+        {
+          m_bicK = std::pow ((m_lastMaxCwnd - segCwnd) / m_c, 1 / 3.);
+          m_bicOriginPoint = m_lastMaxCwnd;
+          NS_LOG_DEBUG ("lastMaxCwnd > m_cWnd. K=" << m_bicK <<
+                        " and origin=" << m_lastMaxCwnd);
+        }
+    }
+
+  t = Simulator::Now () + m_delayMin - m_epochStart;
+
+  if (t.GetSeconds () < m_bicK)       /* t - K */
+    {
+      offs = m_bicK - t.GetSeconds ();
+      NS_LOG_DEBUG ("t=" << t.GetSeconds () << " <k: offs=" << offs);
+    }
+  else
+    {
+      offs = t.GetSeconds () - m_bicK;
+      NS_LOG_DEBUG ("t=" << t.GetSeconds () << " >= k: offs=" << offs);
+    }
+
+
+  /* Constant value taken from Experimental Evaluation of Cubic Tcp, available at
+   * eprints.nuim.ie/1716/1/Hamiltonpfldnet2007_cubic_final.pdf */
+  delta = m_c * std::pow (offs, 3);
+
+  NS_LOG_DEBUG ("delta: " << delta);
+
+  if (t.GetSeconds () < m_bicK)
+    {
+      // below origin
+      bicTarget = m_bicOriginPoint - delta;
+      NS_LOG_DEBUG ("t < k: Bic Target: " << bicTarget);
+    }
+  else
+    {
+      // above origin
+      bicTarget = m_bicOriginPoint + delta;
+      NS_LOG_DEBUG ("t >= k: Bic Target: " << bicTarget);
+    }
+
+  // Next the window target is converted into a cnt or count value. CUBIC will
+  // wait until enough new ACKs have arrived that a counter meets or exceeds
+  // this cnt value. This is how the CUBIC implementation simulates growing
+  // cwnd by values other than 1 segment size.
+  if (bicTarget > segCwnd)
+    {
+      cnt = segCwnd / (bicTarget - segCwnd);
+      NS_LOG_DEBUG ("target>cwnd. cnt=" << cnt);
+    }
+  else
+    {
+      cnt = 100 * segCwnd;
+    }
+
+  if (m_lastMaxCwnd == 0 && cnt > m_cntClamp)
+    {
+      cnt = m_cntClamp;
+    }
+
+  // The maximum rate of cwnd increase CUBIC allows is 1 packet per
+  // 2 packets ACKed, meaning cwnd grows at 1.5x per RTT.
+  return std::max (cnt, 2U);
+}
+
+void
+TcpCubic::PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked,
+                     const Time &rtt)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked << rtt);
+
+  /* Discard delay samples right after fast recovery */
+  if (m_epochStart != Time::Min ()
+      && (Simulator::Now () - m_epochStart) < m_cubicDelta)
+    {
+      return;
+    }
+
+  /* first time call or link delay decreases */
+  if (m_delayMin == Time::Min () || m_delayMin > rtt)
+    {
+      m_delayMin = rtt;
+    }
+
+  /* hystart triggers when cwnd is larger than some threshold */
+  if (m_hystart
+      && tcb->m_cWnd <= tcb->m_ssThresh
+      && tcb->m_cWnd >= m_hystartLowWindow * tcb->m_segmentSize)
+    {
+      HystartUpdate (tcb, rtt);
+    }
+}
+
+void
+TcpCubic::HystartUpdate (Ptr<TcpSocketState> tcb, const Time& delay)
+{
+  NS_LOG_FUNCTION (this << delay);
+
+  if (!(m_found & m_hystartDetect))
+    {
+      Time now = Simulator::Now ();
+
+      /* first detection parameter - ack-train detection */
+      if ((now - m_lastAck) <= m_hystartAckDelta)
+        {
+          m_lastAck = now;
+
+          if ((now - m_roundStart) > m_delayMin)
+            {
+              m_found |= PACKET_TRAIN;
+            }
+        }
+
+      /* obtain the minimum delay of more than sampling packets */
+      if (m_sampleCnt < m_hystartMinSamples)
+        {
+          if (m_currRtt == Time::Min () || m_currRtt > delay)
+            {
+              m_currRtt = delay;
+            }
+
+          ++m_sampleCnt;
+        }
+      else
+        {
+          if (m_currRtt > m_delayMin +
+              HystartDelayThresh (m_delayMin))
+            {
+              m_found |= DELAY;
+            }
+        }
+      /*
+       * Either one of two conditions are met,
+       * we exit from slow start immediately.
+       */
+      if (m_found & m_hystartDetect)
+        {
+          NS_LOG_DEBUG ("Exit from SS, immediately :-)");
+          tcb->m_ssThresh = tcb->m_cWnd;
+        }
+    }
+}
+
+Time
+TcpCubic::HystartDelayThresh (const Time& t) const
+{
+  NS_LOG_FUNCTION (this << t);
+
+  Time ret = t;
+  if (t > m_hystartDelayMax)
+    {
+      ret = m_hystartDelayMax;
+    }
+  else if (t < m_hystartDelayMin)
+    {
+      ret = m_hystartDelayMin;
+    }
+
+  return ret;
+}
+
+uint32_t
+TcpCubic::GetSsThresh (Ptr<const TcpSocketState> tcb, uint32_t bytesInFlight)
+{
+  NS_LOG_FUNCTION (this << tcb << bytesInFlight);
+
+  // Without inflation and deflation, these two are the same
+  uint32_t segInFlight = bytesInFlight / tcb->m_segmentSize;
+  uint32_t segCwnd = tcb->GetCwndInSegments ();
+  NS_LOG_DEBUG ("Loss at cWnd=" << segCwnd << " in flight=" << segInFlight);
+
+  /* Wmax and fast convergence */
+  if (segCwnd < m_lastMaxCwnd && m_fastConvergence)
+    {
+      m_lastMaxCwnd = (segCwnd * (1 + m_beta)) / 2; // Section 4.6 in RFC 8312
+    }
+  else
+    {
+      m_lastMaxCwnd = segCwnd;
+    }
+
+  m_epochStart = Time::Min ();    // end of epoch
+
+  /* Formula taken from the Linux kernel */
+  uint32_t ssThresh = std::max (static_cast<uint32_t> (segInFlight * m_beta ), 2U) * tcb->m_segmentSize;
+
+  NS_LOG_DEBUG ("SsThresh = " << ssThresh);
+
+  return ssThresh;
+}
+
+void
+TcpCubic::CongestionStateSet (Ptr<TcpSocketState> tcb, const TcpSocketState::TcpCongState_t newState)
+{
+  NS_LOG_FUNCTION (this << tcb << newState);
+
+  if (newState == TcpSocketState::CA_LOSS)
+    {
+      CubicReset (tcb);
+      HystartReset (tcb);
+    }
+}
+
+void
+TcpCubic::CubicReset (Ptr<const TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+
+  m_lastMaxCwnd = 0;
+  m_bicOriginPoint = 0;
+  m_bicK = 0;
+  m_delayMin = Time::Min ();
+  m_found = false;
+}
+
+Ptr<TcpCongestionOps>
+TcpCubic::Fork (void)
+{
+  NS_LOG_FUNCTION (this);
+  return CopyObject<TcpCubic> (this);
+}
+
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-cubic.h ns-3.33/src/internet/model/tcp-cubic.h
--- ns-3.32/src/internet/model/tcp-cubic.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/internet/model/tcp-cubic.h	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,169 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2014 Natale Patriciello <natale.patriciello@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#ifndef TCPCUBIC_H
+#define TCPCUBIC_H
+
+#include "ns3/tcp-congestion-ops.h"
+#include "ns3/tcp-socket-base.h"
+
+
+namespace ns3 {
+
+/**
+ * \brief The Cubic Congestion Control Algorithm
+ *
+ * TCP Cubic is a protocol that enhances the fairness property
+ * of Bic while retaining its scalability and stability. The main feature is
+ * that the window growth function is defined in real time in order to be independent
+ * from the RTT. More specifically, the congestion window of Cubic is determined
+ * by a function of the elapsed time from the last window reduction.
+ *
+ * The Cubic code is quite similar to that of Bic.
+ * The main difference is located in the method Update, an edit
+ * necessary for satisfying the Cubic window growth, that can be tuned with
+ * the attribute C (the Cubic scaling factor).
+ *
+ * Following the Linux implementation, we included the Hybrid Slow Start,
+ * that effectively prevents the overshooting of slow start
+ * while maintaining a full utilization of the network. This new type of slow
+ * start can be disabled through the \Attribute{HyStart} attribute.
+ *
+ * CUBIC TCP is implemented and used by default in Linux kernels 2.6.19
+ * and above; this version follows the implementation in Linux 3.14, which
+ * slightly differ from the CUBIC paper. It also features HyStart.
+ *
+ * Home page:
+ *      http://netsrv.csc.ncsu.edu/twiki/bin/view/Main/BIC
+ * The work starts from the implementation of CUBIC TCP in
+ * Sangtae Ha, Injong Rhee and Lisong Xu,
+ * "CUBIC: A New TCP-Friendly High-Speed TCP Variant"
+ * in ACM SIGOPS Operating System Review, July 2008.
+ * Available from:
+ *  http://netsrv.csc.ncsu.edu/export/cubic_a_new_tcp_2008.pdf
+ *
+ * CUBIC integrates a new slow start algorithm, called HyStart.
+ * The details of HyStart are presented in
+ *  Sangtae Ha and Injong Rhee,
+ *  "Taming the Elephants: New TCP Slow Start", NCSU TechReport 2008.
+ * Available from:
+ *  http://netsrv.csc.ncsu.edu/export/hystart_techreport_2008.pdf
+ *
+ * More information on this implementation: http://dl.acm.org/citation.cfm?id=2756518
+ */
+class TcpCubic : public TcpCongestionOps
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  TcpCubic ();
+  TcpCubic (const TcpCubic& sock);
+
+  virtual std::string GetName () const;
+  virtual void PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked, const Time& rtt);
+  virtual void IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
+  virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb, uint32_t bytesInFlight);
+  virtual void CongestionStateSet (Ptr<TcpSocketState> tcb,
+                                   const TcpSocketState::TcpCongState_t newState);
+
+  virtual Ptr<TcpCongestionOps> Fork ();
+
+private:
+  /**
+   * \brief Values to detect the Slow Start mode of HyStart
+   */
+  enum HybridSSDetectionMode
+  {
+    PACKET_TRAIN = 0x1, //!< Detection by trains of packet
+    DELAY        = 0x2  //!< Detection by delay value
+  };
+
+  bool     m_fastConvergence;  //!< Enable or disable fast convergence algorithm
+  double   m_beta;             //!< Beta for cubic multiplicative increase
+
+  bool     m_hystart;          //!< Enable or disable HyStart algorithm
+  int      m_hystartDetect;    //!< Detect way for HyStart algorithm \see HybridSSDetectionMode
+  uint32_t m_hystartLowWindow; //!< Lower bound cWnd for hybrid slow start (segments)
+  Time     m_hystartAckDelta;  //!< Spacing between ack's indicating train
+  Time     m_hystartDelayMin;  //!< Minimum time for hystart algorithm
+  Time     m_hystartDelayMax;  //!< Maximum time for hystart algorithm
+  uint8_t  m_hystartMinSamples; //!< Number of delay samples for detecting the increase of delay
+
+  uint32_t m_initialCwnd;      //!< Initial cWnd
+  uint8_t  m_cntClamp;         //!< Modulo of the (avoided) float division for cWnd
+
+  double   m_c;                //!< Cubic Scaling factor
+
+  // Cubic parameters
+  uint32_t     m_cWndCnt;         //!<  cWnd integer-to-float counter
+  uint32_t     m_lastMaxCwnd;     //!<  Last maximum cWnd
+  uint32_t     m_bicOriginPoint;  //!<  Origin point of bic function
+  double       m_bicK;            //!<  Time to origin point from the beginning
+                                  //    of the current epoch (in s)
+  Time         m_delayMin;        //!<  Min delay
+  Time         m_epochStart;      //!<  Beginning of an epoch
+  bool         m_found;           //!<  The exit point is found?
+  Time         m_roundStart;      //!<  Beginning of each round
+  SequenceNumber32   m_endSeq;    //!<  End sequence of the round
+  Time         m_lastAck;         //!<  Last time when the ACK spacing is close
+  Time         m_cubicDelta;      //!<  Time to wait after recovery before update
+  Time         m_currRtt;         //!<  Current Rtt
+  uint32_t     m_sampleCnt;       //!<  Count of samples for HyStart
+
+private:
+  /**
+   * \brief Reset HyStart parameters
+   */
+  void HystartReset (Ptr<const TcpSocketState> tcb);
+
+  void CubicReset (Ptr<const TcpSocketState> tcb);
+
+  /**
+   * \brief Cubic window update after a new ack received
+   */
+  uint32_t Update (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Update HyStart parameters
+   *
+   * \param tcb Transmission Control Block of the connection
+   * \param delay Delay for HyStart algorithm
+   */
+  void HystartUpdate (Ptr<TcpSocketState> tcb, const Time &delay);
+
+  /**
+   * \brief Clamp time value in a range
+   *
+   * The returned value is t, clamped in a range specified
+   * by attributes (HystartDelayMin < t < HystartDelayMax)
+   *
+   * \param t Time value to clamp
+   * \return t itself if it is in range, otherwise the min or max
+   * value
+   */
+  Time HystartDelayThresh (const Time &t) const;
+};
+
+} // namespace ns3
+
+#endif // TCPCUBIC_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-dctcp.cc ns-3.33/src/internet/model/tcp-dctcp.cc
--- ns-3.32/src/internet/model/tcp-dctcp.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-dctcp.cc	2021-01-09 10:19:22.000000000 -0800
@@ -21,7 +21,7 @@
 
 #include "tcp-dctcp.h"
 #include "ns3/log.h"
-#include "math.h"
+#include "ns3/abort.h"
 #include "ns3/tcp-socket-state.h"
 
 namespace ns3 {
@@ -33,7 +33,7 @@
 TypeId TcpDctcp::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::TcpDctcp")
-    .SetParent<TcpNewReno> ()
+    .SetParent<TcpLinuxReno> ()
     .AddConstructor<TcpDctcp> ()
     .SetGroupName ("Internet")
     .AddAttribute ("DctcpShiftG",
@@ -44,13 +44,17 @@
     .AddAttribute ("DctcpAlphaOnInit",
                    "Initial alpha value",
                    DoubleValue (1.0),
-                   MakeDoubleAccessor (&TcpDctcp::SetDctcpAlpha),
+                   MakeDoubleAccessor (&TcpDctcp::InitializeDctcpAlpha),
                    MakeDoubleChecker<double> (0, 1))
     .AddAttribute ("UseEct0",
                    "Use ECT(0) for ECN codepoint, if false use ECT(1)",
                    BooleanValue (true),
                    MakeBooleanAccessor (&TcpDctcp::m_useEct0),
                    MakeBooleanChecker ())
+    .AddTraceSource ("CongestionEstimate",
+                     "Update sender-side congestion estimate state",
+                     MakeTraceSourceAccessor (&TcpDctcp::m_traceCongestionEstimate),
+                     "ns3::TcpDctcp::CongestionEstimateTracedCallback")
   ;
   return tid;
 }
@@ -61,21 +65,22 @@
 }
 
 TcpDctcp::TcpDctcp ()
-  : TcpNewReno ()
+  : TcpLinuxReno (),
+    m_ackedBytesEcn (0),
+    m_ackedBytesTotal (0),
+    m_priorRcvNxt (SequenceNumber32 (0)),
+    m_priorRcvNxtFlag (false),
+    m_nextSeq (SequenceNumber32 (0)),
+    m_nextSeqFlag (false),
+    m_ceState (false),
+    m_delayedAckReserved (false),
+    m_initialized (false)
 {
   NS_LOG_FUNCTION (this);
-  m_ackedBytesEcn = 0;
-  m_ackedBytesTotal = 0;
-  m_priorRcvNxt = SequenceNumber32 (0);
-  m_priorRcvNxtFlag = false;
-  m_nextSeq = SequenceNumber32 (0);
-  m_nextSeqFlag = false;
-  m_ceState = false;
-  m_delayedAckReserved = false;
 }
 
 TcpDctcp::TcpDctcp (const TcpDctcp& sock)
-  : TcpNewReno (sock),
+  : TcpLinuxReno (sock),
     m_ackedBytesEcn (sock.m_ackedBytesEcn),
     m_ackedBytesTotal (sock.m_ackedBytesTotal),
     m_priorRcvNxt (sock.m_priorRcvNxt),
@@ -86,7 +91,8 @@
     m_ceState (sock.m_ceState),
     m_delayedAckReserved (sock.m_delayedAckReserved),
     m_g (sock.m_g),
-    m_useEct0 (sock.m_useEct0)
+    m_useEct0 (sock.m_useEct0),
+    m_initialized (sock.m_initialized)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -110,14 +116,17 @@
   tcb->m_useEcn = TcpSocketState::On;
   tcb->m_ecnMode = TcpSocketState::DctcpEcn;
   tcb->m_ectCodePoint = m_useEct0 ? TcpSocketState::Ect0 : TcpSocketState::Ect1;
+  m_initialized = true;
 }
 
-void
-TcpDctcp::ReduceCwnd (Ptr<TcpSocketState> tcb)
+// Step 9, Section 3.3 of RFC 8257.  GetSsThresh() is called upon
+// entering the CWR state, and then later, when CWR is exited,
+// cwnd is set to ssthresh (this value).  bytesInFlight is ignored.
+uint32_t
+TcpDctcp::GetSsThresh (Ptr<const TcpSocketState> tcb, uint32_t bytesInFlight)
 {
-  NS_LOG_FUNCTION (this << tcb);
-  uint32_t val = static_cast<uint32_t> ((1 - m_alpha / 2.0) * tcb->m_cWnd);
-  tcb->m_cWnd = std::max (val, 2 * tcb->m_segmentSize);
+  NS_LOG_FUNCTION (this << tcb << bytesInFlight);
+  return static_cast<uint32_t> ((1 - m_alpha / 2.0) * tcb->m_cWnd);
 }
 
 void
@@ -136,21 +145,23 @@
     }
   if (tcb->m_lastAckedSeq >= m_nextSeq)
     {
-      double bytesEcn = 0.0;
+      double bytesEcn = 0.0; // Corresponds to variable M in RFC 8257
       if (m_ackedBytesTotal >  0)
         {
           bytesEcn = static_cast<double> (m_ackedBytesEcn * 1.0 / m_ackedBytesTotal);
         }
       m_alpha = (1.0 - m_g) * m_alpha + m_g * bytesEcn;
+      m_traceCongestionEstimate (m_ackedBytesEcn, m_ackedBytesTotal, m_alpha);
       NS_LOG_INFO (this << "bytesEcn " << bytesEcn << ", m_alpha " << m_alpha);
       Reset (tcb);
     }
 }
 
 void
-TcpDctcp::SetDctcpAlpha (double alpha)
+TcpDctcp::InitializeDctcpAlpha (double alpha)
 {
   NS_LOG_FUNCTION (this << alpha);
+  NS_ABORT_MSG_IF (m_initialized, "DCTCP has already been initialized");
   m_alpha = alpha;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-dctcp.h ns-3.33/src/internet/model/tcp-dctcp.h
--- ns-3.32/src/internet/model/tcp-dctcp.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-dctcp.h	2021-01-09 10:19:22.000000000 -0800
@@ -23,6 +23,8 @@
 #define TCP_DCTCP_H
 
 #include "ns3/tcp-congestion-ops.h"
+#include "ns3/tcp-linux-reno.h"
+#include "ns3/traced-callback.h"
 
 namespace ns3 {
 
@@ -33,7 +35,7 @@
  * endpoint capabilities mentioned in the DCTCP SIGCOMM paper.
  */
 
-class TcpDctcp : public TcpNewReno
+class TcpDctcp : public TcpLinuxReno
 {
 public:
   /**
@@ -71,9 +73,19 @@
    */
   virtual void Init (Ptr<TcpSocketState> tcb);
 
+  /**
+   * TracedCallback signature for DCTCP update of congestion state
+   *
+   * \param [in] bytesAcked Bytes acked in this observation window
+   * \param [in] bytesMarked Bytes marked in this observation window
+   * \param [in] alpha New alpha (congestion estimate) value
+   */
+  typedef void (* CongestionEstimateTracedCallback)(uint32_t bytesAcked, uint32_t bytesMarked, double alpha);
+
   // Documented in base class
+  virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
+                                uint32_t bytesInFlight);
   virtual Ptr<TcpCongestionOps> Fork ();
-  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
   virtual void PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked,
                           const Time &rtt);
   virtual void CwndEvent (Ptr<TcpSocketState> tcb,
@@ -110,11 +122,11 @@
   void Reset (Ptr<TcpSocketState> tcb);
 
   /**
-   * \brief Sets the value of m_alpha
+   * \brief Initialize the value of m_alpha
    *
    * \param alpha DCTCP alpha parameter
    */
-  void SetDctcpAlpha (double alpha);
+  void InitializeDctcpAlpha (double alpha);
 
   uint32_t m_ackedBytesEcn;             //!< Number of acked bytes which are marked
   uint32_t m_ackedBytesTotal;           //!< Total number of acked bytes
@@ -127,6 +139,11 @@
   bool m_delayedAckReserved;            //!< Delayed Ack state
   double m_g;                           //!< Estimation gain
   bool m_useEct0;                       //!< Use ECT(0) for ECN codepoint
+  bool m_initialized;                   //!< Whether DCTCP has been initialized
+  /**
+   * \brief Callback pointer for congestion state update
+   */
+  TracedCallback<uint32_t, uint32_t, double> m_traceCongestionEstimate;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-linux-reno.cc ns-3.33/src/internet/model/tcp-linux-reno.cc
--- ns-3.32/src/internet/model/tcp-linux-reno.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-linux-reno.cc	2021-01-09 10:19:22.000000000 -0800
@@ -132,14 +132,6 @@
   return std::max<uint32_t> (2 * state->m_segmentSize, state->m_cWnd / 2);
 }
 
-void
-TcpLinuxReno::ReduceCwnd (Ptr<TcpSocketState> tcb)
-{
-  NS_LOG_FUNCTION (this << tcb);
-
-  tcb->m_cWnd = std::max ( tcb->m_cWnd.Get () / 2, tcb->m_segmentSize);
-}
-
 Ptr<TcpCongestionOps>
 TcpLinuxReno::Fork ()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-linux-reno.h ns-3.33/src/internet/model/tcp-linux-reno.h
--- ns-3.32/src/internet/model/tcp-linux-reno.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-linux-reno.h	2021-01-09 10:19:22.000000000 -0800
@@ -52,7 +52,6 @@
   virtual void IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
   virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
                                 uint32_t bytesInFlight);
-  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
   virtual Ptr<TcpCongestionOps> Fork ();
 
 protected:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-prr-recovery.cc ns-3.33/src/internet/model/tcp-prr-recovery.cc
--- ns-3.32/src/internet/model/tcp-prr-recovery.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-prr-recovery.cc	2021-01-09 10:19:22.000000000 -0800
@@ -124,7 +124,6 @@
 TcpPrrRecovery::ExitRecovery (Ptr<TcpSocketState> tcb)
 {
   NS_LOG_FUNCTION (this << tcb);
-  tcb->m_cWnd = tcb->m_ssThresh.Get ();
   tcb->m_cWndInfl = tcb->m_cWnd;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-recovery-ops.cc ns-3.33/src/internet/model/tcp-recovery-ops.cc
--- ns-3.32/src/internet/model/tcp-recovery-ops.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-recovery-ops.cc	2021-01-09 10:19:22.000000000 -0800
@@ -118,9 +118,9 @@
   NS_LOG_FUNCTION (this << tcb);
   // Follow NewReno procedures to exit FR if SACK is disabled
   // (RFC2582 sec.3 bullet #5 paragraph 2, option 2)
-  // For SACK connections, we maintain the cwnd = ssthresh. In fact,
-  // this ACK was received in RECOVERY phase, not in OPEN. So we
-  // are not allowed to increase the window
+  // In this implementation, actual m_cWnd value is reset to ssThresh
+  // immediately before calling ExitRecovery(), so we just need to
+  // reset the inflated cWnd trace variable
   tcb->m_cWndInfl = tcb->m_ssThresh.Get ();
 }
 
